package hdm.mi.growbros.controllers;

import hdm.mi.growbros.models.plant.Plant;
import hdm.mi.growbros.models.plant.WaterDemand;
import hdm.mi.growbros.models.search.SearchRequest;
import hdm.mi.growbros.service.PlantsService;
import jakarta.validation.Valid;
import org.springframework.web.bind.annotation.*;

import java.util.Collection;

@RestController
@CrossOrigin
public class PlantsController {
    private final PlantsService plantsService;

    public PlantsController(PlantsService plantsService) {
        this.plantsService = plantsService;
    }

    @GetMapping("/api/v1/plants")
    public Collection<Plant> getAllPlants() {
        return plantsService.getPlants();
    }

    @GetMapping("api/v1/plants/randomPlants/{numberOfPlants}")
    public Collection<Plant> getRandomPlants(@PathVariable Integer numberOfPlants) {return plantsService.getRandomPlants(numberOfPlants);}

    @GetMapping("api/v1/plants/search")
    public Collection<Plant> getPlantsSearchedFor(@RequestBody @Valid SearchRequest searchRequest){
        return plantsService.getPlantsSearchedFor(searchRequest);
    }
    @PostMapping("/api/v1/plants")
    public void createPlant(@RequestBody @Valid Plant plant) {
        plantsService.createPlant(plant);
    }
}
